package bdd;

/**
 * 
 */

public final class Node
{
	private int variable;
	private Node low;
	private Node high;
	
	public static final Node ONE = new Node(7);
	
	public static final Node ZERO = new Node(7);
	
	Node(int var, Node low, Node high)
	{
		this.variable = var;
		this.low = low;
		this.high = high;
	}
	
	Node(int var)
	{
		this(var, null, null);
	}
	
	public int getVar()
	{
		return variable;
	}
	
	public Node getLow()
	{
		return low;
	}
	
	public Node getHigh()
	{
		return high;
	}
	
	public boolean eval(boolean[] valuation)
	{
		return eval(valuation, 0);
	}
	
	private boolean eval(boolean[] valuation, int index)
	{
		if (this == ONE) {
			return true;
		}
		else if (this == ZERO) {
			return false;
		}
		else if (variable == index) {
			if (valuation[index]) {
				return high.eval(valuation, index + 1);
			}
			else {
				return low.eval(valuation, index + 1);
			}
		}
		else {
			return eval(valuation, index + 1);
		}
	}
	
	@Override
	public boolean equals(Object obj) 
	{
		if (obj instanceof Node) {
			Node other = (Node)obj;
			return variable == other.variable && low == other.low
				&& high == other.high;
		}
		return false;
	}
	
	@Override
	public int hashCode() 
	{
		int lowVar = low != null ? low.variable : -1;
		int highVar = high != null ? high.variable : -2;
		// use bijection
		int hash = ((lowVar + highVar) * (lowVar + highVar + 1)) / 2 + lowVar;
		return ((variable + hash) * (variable + hash + 1)) / 2 + variable;
	}
}
