package bdd;


public class Operators {

	public static final EqualOperator EQUALS = new EqualOperator();
	
	public static final AndOperator AND = new AndOperator();
	
	public static final OrOperator OR = new OrOperator();
	
	public static final LessEqualOperator LESS_EQUALS = new LessEqualOperator();
	
	public static final ComplementOperator COMPLEMENT = new ComplementOperator();
	
	public static class AndOperator implements Operator
	{

		public boolean op(boolean op1, boolean op2) 
		{
			return op1 && op2;
		}
		
	}
	
	public static class OrOperator implements Operator
	{
		public boolean op(boolean op1, boolean op2) 
		{
			return op1 || op2;
		}
	}

	public static class LessEqualOperator implements Operator
	{

		public boolean op(boolean op1, boolean op2)
		{
			return (!op1 || op2);
		}

	}

	public static class EqualOperator implements Operator
	{
		
		public boolean op(boolean op1, boolean op2)
		{
			return op1 == op2;
		}

	}
	
	public static class ComplementOperator implements Operator
	{

		public boolean op(boolean op1, boolean op2) 
		{
			return !op1;
		}
		
	}
	
}
