package bresenham;

import java.awt.Point;

/**
 * 
 * Modifications:
 * 
 *  Added default constructor
 *  Diagram no longer extends Canvas
 *  negative comparison removed
 *  
 *  Results:
 *  
 *  branches for negative value cases are not covered
 *
 */
public class Bresenham {
	 Diagram d;
	    /** Draw a line connecting two points. **/
	    void drawLine(int x0,int y0,int x1,int y1){
	       int dx = x1 - x0;
	       int dy = y1 - y0;
	       int ex, ey, height;

	       /** 
	        ** ex,ey are set to be unit vectors in the direction of dx and
	        ** dy, which are set to magnitiude of original differences
	        **/
	       if (dx > 0){
	    	   ex = 1;
	       } else if (dx == 0) {
	    	   ex = 0;
	       } else {
	    	   ex = -1;
	    	   dx = -dx;
	       }
	       if (dy > 0){
	          ey = 1;
	       }else if (dy < 0){
	          ey = -1;
	          dy = -dy;
	       }else{
	          ey = 0;
	       }

	       /** x, y define the current point **/
	       int x = x0, y = y0;
	       if (dx > dy){
	          height = 2*dy -dx;
	          while(x != x1){
	             if(height >= 0){
	                height -= 2*dx;
	                y += ey;
	             }
	             height += 2*dy;
	             x += ex;
	             d.setPixel(x, y);
	          }
	       }else{
	          height = 2*dx -dy;
	          while(y != y1){
	             if(height >= 0){
	                height -= 2*dy;
	                x += ex;
	             }
	             height += 2*dx;
	             y += ey;
	             d.setPixel(x, y);
	          }
	       }
	    }

	    Bresenham(Diagram d){
	        this.d = d;
	    }
	    
	    Bresenham() {
	    	this(new Diagram());
	    }

	    public void drawLine(Point p, Point q){
	        d.setPixel(p.x, p.y);
	        drawLine(p.x, p.y, q.x, q.y);
	    }
}
