package examples;

import de.uni_stuttgart.fmi.szs.jmoped.annotation.PDSArrayBits;
import de.uni_stuttgart.fmi.szs.jmoped.annotation.PDSParameterBits;

public class ArrayUtils 
{
	@PDSParameterBits(2)
	@PDSArrayBits(1)
	public static void verifyReversal(int[] array)
	{
		int[] copy = new int[array.length];
		for (int i = 0; i < copy.length; i++) {
			copy[i] = array[i];
		}
		reverse(array);
		for (int i = 0; i < copy.length; i++) {
			assert(copy[i] == array[copy.length - 1 - i]);
		}
	}
	
	/**
	 * <p>Reverses the order of the given array.</p>
	 * 
	 * <p>This method does nothing if <code>null</code> array input.</p>
	 * 
	 * @param array  the array to reverse, may be <code>null</code>
	 */
	public static void reverse(int[] array) {
		if (array == null) {
			return;
		}
		int i = 0;
		int j = array.length - 1;
		int tmp;
		while (j > i) {
			tmp = array[j];
			array[j] = array[i];
			array[i] = tmp;
			j--;
			i++;
		}
	}	
	
}
